(function () {
    "use strict";

    angular.module('core').controller('vendedorController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$q', '$alert', 'contatoService', 'lookupService'];

    function controller($scope, $timeout, $state, $q, $alert, contatoService, lookupService) {
        $scope.initializeLayout('Vendedores');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            carregandoMais: false,
            salvando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    ativo: null,
                    cpf: '',
                    chavesEmpresa: '',
                    indicaCliente: null,
                    indicaFornecedor: null,
                    indicaVendedor: true,
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            },
        };
        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function (action) {

                    if (
                        (!angular.isUndefined($scope.popups.add.data.Vendedor) && $scope.popups.add.data.Vendedor != null) &&
                        !angular.isUndefined($scope.popups.add.data.Vendedor.Filial && $scope.popups.add.data.Vendedor.Filial != null) &&
                        !angular.isUndefined($scope.popups.add.data.Vendedor.Filial.Empresa && $scope.popups.add.data.Vendedor.Filial.Empresa != null))
                        $scope.popups.add.data.Empresa = $scope.popups.add.data.Vendedor.Filial.Empresa


                     
                    if ($scope.popups.add.data.Nome == null || angular.isUndefined($scope.popups.add.data.Nome)) {

                        if ($scope.popups.add.steps.index == 0)
                            $scope.popups.add.steps.next();
                        else
                            $alert({ text: 'Necessário adicionar o nome do vendedor para poder continuar o processo de cadastro.', title: 'Atenção' });

                        return;
                    }


                    contatoService
                        .save($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ text: response.Message, title: $scope.Title });
                                } else {
                                    $scope.popups.add.steps.step2.pass.set();
                                    $scope.popups.add.ativo = false;
                                    $scope.popups.add.data = {};
                                    $scope.refresh();

                                    if (action == $scope.popups.add.saveAction.saveAndNew) {
                                        $scope.popups.add.steps.index = 0;
                                        $scope.popups.add.toggle();
                                    }
                                    else if (action == $scope.popups.add.saveAction.saveAndEdit) {
                                        $state.go("state-vendedor-edit", { id: response.Data.ID });
                                    }
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                saveAction: {
                    save: 0, saveAndNew: 1, saveAndEdit: 2
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                        $('[ng-model$="popups.add.data.Codigo"]').focus();
                    }
                },
                prepare: function () {
                    contatoService
                        .prepareNewVendedor()
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                    $scope.popups.add.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $scope.popups.add.ativo = true;
                                }
                            },
                            function (_error) {
                                $scope.popups.add.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                steps: {
                    index: 0,
                    count: 3,
                    next: function () {
                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    },
                    step0: {
                        checkCPF: function () {
                            debugger
                            /* Esta verificação chega se CPF já existe. 
                            Se já existe, recupera o contato para que o usuário possa ir para o seu cadastro.
                            Se não existe, explica que o usuário pode continuar com o processo de inclusão.
                            */
                            $scope.popups.add.steps.step0.materiaIcon = '';
                            $scope.popups.add.steps.step0.mensagem = '';
                            $scope.popups.add.steps.step0.contatoExistente = {};

                            /* Se não preencheu o CPF apenas limpa o resultado da pesquisa anterior (já limpou) */
                            if (!$scope.popups.add.data.CPF) {
                                return;
                            };
                            $scope.state.salvando = true;

                            var args = { filtro: { CPF: $scope.popups.add.data.CPF, take: 1 } };
                            contatoService
                                .getAll(args)
                                .then(
                                    function (response) {
                                        if (response.Status < 0) {
                                            $alert({ title: $scope.Title, text: response.Message });
                                        } else {
                                            if (response.Data.length > 0) {
                                                $scope.popups.add.steps.step0.materialIcon = 'pan_tool';
                                                $scope.popups.add.steps.step0.mensagem = "Este CPF já está cadastado em nossas bases de dados."
                                                $scope.popups.add.steps.step0.contatoExistente = response.Data[0];
                                            } else {
                                                $scope.popups.add.steps.step0.materialIcon = 'thumb_up';
                                                $scope.popups.add.steps.step0.mensagem = "CPF ainda não foi utilizado. Para continuar clique em 'avançar'."
                                            }
                                        }
                                        $scope.state.salvando = false;
                                    },
                                    function (_error) {
                                        $scope.state.salvando = false;
                                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                                    });
                        },
                        materialIcon: '',
                        mensagem: '',
                        contatoExistente: {},
                    },
                    step1: {},
                    step2: {
                        pass: {
                            value: '',
                            visible: false,
                            set: function () {
                                var args = {
                                    id: $scope.popups.add.data.ID,
                                    senha: $scope.popups.add.steps.step2.pass.value
                                };
                                //contatoService
                                //    .setSenhaVendedor(args)
                                //    .then(
                                //    function (response) {
                                //        if (response.Status < 0) {
                                //            $alert({ text: response.Message, title: $scope.Title });
                                //        }
                                //    },
                                //    function (_error) {
                                //        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                                //    });
                            },
                        },
                    },
                },
            }
        };
        $scope.auxiliar = {
            loja: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllLoja({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            estado: {
                data: [],
                args: {},
                getAll: function () {
                    lookupService
                        .getAllEstado($scope.auxiliar.estado.args)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    angular.copy(angular.fromJson(response.Data), $scope.auxiliar.estado.data);
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
            },
            endereco: {
                prepare: function (index) {
                    contatoService
                        .prepareEndereco($scope.state.item.Enderecos[index])
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item.Enderecos[index] = response.Data;
                                    $('[ng-model$="item.Linha2"]').focus();
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            contatoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            contatoService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            $scope.state.carregandoMais = true;
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            contatoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                        $scope.state.carregandoMais = false;
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        $scope.state.carregandoMais = false;
                    });
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args.chaves = '';
            $scope.state.filtro.args.ativo = null;
            $scope.state.filtro.args.cpf = '';
            $scope.state.filtro.args.chavesEmpresa = '';
            $scope.state.filtro.args.indicaCliente = null;
            $scope.state.filtro.args.indicaFornecedor = null;
            $scope.state.filtro.args.indicaVendedor = true;

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();